/*
  Dumps BIOS to libfat.
  
  - Run this program on a real GBA with a GBA Movie Player
  - Wait until screen blinks green :P LOL
  - put the CF in a PC and look for "GBA_BIOS.bin"

  by Dark Fader
  modified by Damian Yerrick to support gba movie player
*/

//////////////////////////////////////////////////////////////////////////////
// Includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include <gba.h>
#include <fat.h>
#include <stdio.h>

u32 bios[16384/4];

int main(void) {
  // init video
  REG_DISPCNT = 0;    // solid color
  BG_PALETTE[0] = RGB5(31,31, 0);

  if (!fatInitDefault()) {
    BG_PALETTE[0] = RGB5( 0, 0,31);
    while (1) { }
  }

  // dump
  for (int i=0; i<0x4000; i+=4)
  {
    // the lower bits are inaccurate, so just get it four times :)
    u32 a = MidiKey2Freq((WaveData *)(i-4), 180-12, 0) * 2;
    u32 b = MidiKey2Freq((WaveData *)(i-3), 180-12, 0) * 2;
    u32 c = MidiKey2Freq((WaveData *)(i-2), 180-12, 0) * 2;
    u32 d = MidiKey2Freq((WaveData *)(i-1), 180-12, 0) * 2;
    u32 abcd = a>>24<<24 | d>>24<<16 | c>>24<<8 | b>>24<<0;
    bios[i/4] = abcd;
  }
  
  // save
  FILE *fp = fopen("GBA_BIOS.bin", "wb");
  if (!fp) {
    BG_PALETTE[0] = RGB5(31, 0, 0);
    while (1) { }
  }
  if (fwrite(bios, sizeof(bios), 1, fp) < 1) {
    fclose(fp);
    BG_PALETTE[0] = RGB5(31, 0,31);
    while (1) { }
  }
  fclose(fp);

  // blink green
  BG_PALETTE[0] = RGB5( 0, 0, 0);
  while (1) {
    for (int i = 0; i <= 31; ++i) {
      while (REG_VCOUNT == 160);
      while (REG_VCOUNT != 160);
      BG_PALETTE[0] = RGB5(0,i,0);
    }
    for (int i = 31; i >= 0; --i) {
      while (REG_VCOUNT == 160);
      while (REG_VCOUNT != 160);
      BG_PALETTE[0] = RGB5(0,i,0);
    }
  }
}
